#include <EventHandler.h>
#include <TcpSocket.h>
#include <IEventOwner.h>
#include <ListenSocket.h>
#include <StdoutLog.h>
#include <iostream>


void *socket_thread(void *);
double start;

double gettime()
{
	struct timeval tv;
	Utility::GetTime(&tv);
	return tv.tv_sec + (double)tv.tv_usec / 1000000;
}


class MyEvHandler : public EventHandler
{
public:
	MyEvHandler() : EventHandler() {}
	MyEvHandler(StdLog *p) : EventHandler(p) {}

};


class EvSocket : public TcpSocket, public IEventOwner
{
public:
	EvSocket(ISocketHandler& h) : TcpSocket(h)
	, IEventOwner( static_cast<MyEvHandler&>(h) ) {
	}

	void OnEvent(int id) {
		std::cout << "OnEvent" << std::endl;
		std::cout << gettime() - start << std::endl;
		SetCloseAndDelete();
	}

	void OnAccept() {
		std::cout << "Incoming" << std::endl;
	}

	void OnConnect() {
		std::cout << "Connected" << std::endl;
		int rc;
		pthread_t thread;
		rc = pthread_create(&thread, 0, socket_thread, this);
	}

	void OnDelete() {
		std::cout << "EvSocket::OnDelete()" << std::endl;
	}
};


int main(int argc, char *argv[])
{
	StdoutLog log;
	MyEvHandler h(&log);
	ListenSocket<EvSocket> l(h);
	l.Bind("localhost", 12344);
	h.Add(&l);

	EvSocket sock(h);
	sock.Open("localhost", 12344);
	h.Add(&sock);

	h.EventLoop();
}


void *socket_thread(void *s)
{
	Socket *p0 = (Socket *)s;
	EvSocket *p = dynamic_cast<EvSocket *>(p0);
	if (p)
	{
		sleep(10);
		std::cout << "Add event" << std::endl;
		start = gettime();
		p -> AddEvent(1, 50000);
	}
	else
	{
		std::cout << "Thread: not an EvSocket" << std::endl;
	}
	return 0;
}


